#ifndef TIMER_H
#define TIMER_H

class CTimer
{

	public:
		//	Timer resolution
		float m_resolution;

	private:
		//	Time frequency
		__int64 m_frequency;

		//	Multimedia timer variables for start times
		unsigned m_mmTimerStart;

		//	Performance counter timer variables for start times
		__int64 m_pcTimerStart;

		//	Using performance counter timer or multimedia timer?
		bool m_usePerformanceCounter;

		//	How many times the timer has been paused successively
		int m_pauseCount;

		//	When the timer was paused
		double m_pauseTime;

	public:
		/*	Constructor. */
		CTimer();

		/*	Reset the timer to zero. */
		void reset();

		/*	Retrieve the time in milliseconds since the timer started. */
		double getTime();

		double getAbsoluteTime();
		/*	Pause this timer. */
		virtual void pause();

		/*	Unpause this timer. */
		virtual void unpause();
};

#endif	// ndef TIMER_H
